//Dostep do wyprodzen mikrokontrolera.

#include "FreeRTOS.h"
#include "task.h"
#include "GPIO_LED.h"
#include "stm32f10x_lib.h"

#define MAX_OUTPUT_LED	( 8 )
#define FIRST_LED			GPIO_Pin_8

static unsigned portSHORT usOutputValue = 0;

void vParTestSetLED( unsigned portBASE_TYPE uxLED, signed portBASE_TYPE xValue )
{
unsigned portSHORT usBit;

	vTaskSuspendAll();
		if( uxLED < MAX_OUTPUT_LED )
		{
			usBit = FIRST_LED << uxLED;

			if( xValue == pdFALSE )
			{
				usBit ^= ( unsigned portSHORT ) 0xffff;
				usOutputValue &= usBit;
			}
			else
				usOutputValue |= usBit;

			GPIO_Write( GPIOC, usOutputValue );
		}	
	xTaskResumeAll();
}
/*-----------------------------------------------------------*/

void vhToggleLED1(void)
{
	GPIO_WriteBit(GPIOB, GPIO_Pin_8, (BitAction)
			((1-GPIO_ReadOutputDataBit(GPIOB, GPIO_Pin_8))));
}

void vhToggleLED2(void)
{
	GPIO_WriteBit(GPIOB, GPIO_Pin_9, (BitAction)
			((1-GPIO_ReadOutputDataBit(GPIOB, GPIO_Pin_9))));
}

void vhToggleLED3(void)
{
	GPIO_WriteBit(GPIOB, GPIO_Pin_10, (BitAction)
			((1-GPIO_ReadOutputDataBit(GPIOB, GPIO_Pin_10))));
}

void vhToggleLED4(void)
{
	GPIO_WriteBit(GPIOB, GPIO_Pin_11, (BitAction)((1-GPIO_ReadOutputDataBit(GPIOB, GPIO_Pin_11))));
}

void vParTestToggleLED( unsigned portBASE_TYPE uxLED )
{
unsigned portSHORT usBit;

	vTaskSuspendAll();
		if( uxLED < MAX_OUTPUT_LED )
		{
			usBit = FIRST_LED << uxLED;

			if( usOutputValue & usBit )
				usOutputValue &= ~usBit;
			else
				usOutputValue |= usBit;

			GPIO_Write( GPIOC, usOutputValue );
		}
	xTaskResumeAll();
}
/*-----------------------------------------------------------*/

