#include <stdlib.h>
/* Scheduler include files. */
#include "FreeRTOS.h"
#include "task.h"
#include "queue.h"
#include "semphr.h"

/* Demo program include files. */
#include "GPIO_LED.h"
#include "taskLED.h"
#include "taskSW.h"

#define ledSTACK_SIZE		configMINIMAL_STACK_SIZE
#define SEM_STACK_SIZE		configMINIMAL_STACK_SIZE

extern xSemaphoreHandle xSemaphoreSW0;
extern xSemaphoreHandle xSemaphoreSW1;
extern xSemaphoreHandle xSemaphoreSW2;

void vTaskSW0(void*);
void vTaskSW1(void*);
void vTaskSW2(void*);

void vStartSWTasks( unsigned portBASE_TYPE uxPriority )
{
	xTaskHandle xHandleTaskSW0, xHandleTaskSW1, xHandleTaskSW2;
	

	// Tworzenie zadania obslugi SW0 i LED1
	xTaskCreate(vTaskSW0, ( signed portCHAR * ) "SW0", 
				ledSTACK_SIZE, NULL, uxPriority, &xHandleTaskSW0);
	// Tworzenie zadania obslugi SW1 i LED2
	xTaskCreate(vTaskSW1, ( signed portCHAR * ) "SW1", 
				ledSTACK_SIZE, NULL, uxPriority, &xHandleTaskSW1);
	// Tworzenie zadania obslugi SW2 i LED3
	xTaskCreate(vTaskSW2, ( signed portCHAR * ) "SW2", 
				ledSTACK_SIZE, NULL, uxPriority, &xHandleTaskSW2);
}

void vTaskSW0(void * pvParameters)
{
	vSemaphoreCreateBinary( xSemaphoreSW0 );
	// Nieskonczona petla zadania
	for(;;)
	{
		if(xSemaphoreTake(xSemaphoreSW0,( portTickType ) 10) == pdTRUE)
		{
			vhToggleLED1();
		}
	}
}

void vTaskSW1(void * pvParameters)
{
	vSemaphoreCreateBinary( xSemaphoreSW1 );
	// Nieskonczona petla zadania
	for(;;)
	{
			if(xSemaphoreTake(xSemaphoreSW1,( portTickType ) 10) == pdTRUE)
			{
				vhToggleLED2();
			}
	}
}

void vTaskSW2(void * pvParameters)
{
	vSemaphoreCreateBinary( xSemaphoreSW2 );
	// Nieskonczona petla zadania
	for(;;)
	{
			if(xSemaphoreTake(xSemaphoreSW2,( portTickType ) 10) == pdTRUE)
			{
				vhToggleLED3();
			}
	}
}
