/* Na podstawie przykladow STMicroelectronics */

#include "stm32f10x_lib.h"
#include "usb_lib.h"
#include "hw_config.h"

TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
TIM_OCInitTypeDef  TIM_OCInitStructure;
void Delay(vu32 nCount);

int main(void)
{
  
#ifdef DEBUG
  	debug();
#endif
  
  	Set_System();
  
  	// Konfiguracja Timera 3
  	TIM_TimeBaseStructure.TIM_Period = 99;
  	TIM_TimeBaseStructure.TIM_Prescaler = 10;
  	TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;
  	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;
  	TIM_TimeBaseInit(TIM3, &TIM_TimeBaseStructure);
  
  	// Konfiguracja kanalu 1
  	TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1;
  	TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
  	TIM_OCInitStructure.TIM_Pulse = 50;
  	TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;
  	TIM_OC1Init(TIM3, &TIM_OCInitStructure);

  	TIM_ARRPreloadConfig(TIM3, ENABLE);
		   
  	// Wlaczenie Timera 3 
  	TIM_Cmd(TIM3, ENABLE);
	  
  	USB_Interrupts_Config();

  	Set_USBClock();

  	USB_Init();

  	while (1);
}

void Delay(vu32 nCount)
{
  	for(; nCount!= 0;nCount--);
}

#ifdef  DEBUG

void assert_failed(u8* file, u32 line)
{ 
  	while(1);
}
#endif

