#include "platform_config.h"
#include "stm32f10x_it.h"
#include "usb_lib.h"
#include "usb_istr.h"

u8 Send_Buffer[2];
extern u32 ADC_ConvertedValueX;
extern u32 ADC_ConvertedValueX_1;

void NMIException(void)
{
}

void HardFaultException(void)
{
  	while (1);
}

void MemManageException(void)
{
  	while (1);
}

void BusFaultException(void)
{
  	while (1);
}

void UsageFaultException(void)
{
  	while (1);
}

void DebugMonitor(void)
{
}

void SVCHandler(void)
{
}

void PendSVC(void)
{
}

void SysTickHandler(void)
{
}

void WWDG_IRQHandler(void)
{
}

void PVD_IRQHandler(void)
{
}

void TAMPER_IRQHandler(void)
{
}

void RTC_IRQHandler(void)
{
}

void FLASH_IRQHandler(void)
{
}

void RCC_IRQHandler(void)
{
}

void EXTI0_IRQHandler(void)
{
  	if(EXTI_GetITStatus(EXTI_Line0) != RESET)
  	{  
    	Send_Buffer[0] = 0x05; // Numer raportu
    
		// Sprawdzenie stanu linii PB0
    	if (GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0) == Bit_RESET)
      		Send_Buffer[1] = 0x01;
    	else 
      		Send_Buffer[1] = 0x00;
    
		// Wyslanie raportu
    	UserToPMABufferCopy(Send_Buffer, ENDP1_TXADDR, 2);
    	SetEPTxCount(ENDP1, 2);
    	SetEPTxValid(ENDP1);

    	EXTI_ClearITPendingBit(EXTI_Line0);
  	}
}

void EXTI1_IRQHandler(void)
{
  	if(EXTI_GetITStatus(EXTI_Line1) != RESET)
  	{  
    	Send_Buffer[0] = 0x06; // Numer raportu
    
		// Sprawdzenie stanu linii PB1
    	if (GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_1) == Bit_RESET)
      		Send_Buffer[1] = 0x01;
    	else 
      		Send_Buffer[1] = 0x00;
    
		// Wyslanie raportu
    	UserToPMABufferCopy(Send_Buffer, ENDP1_TXADDR, 2);
    	SetEPTxCount(ENDP1, 2);
    	SetEPTxValid(ENDP1);

    	EXTI_ClearITPendingBit(EXTI_Line1);
  	}
}

void EXTI2_IRQHandler(void)
{
}

void EXTI3_IRQHandler(void)
{
}

void EXTI4_IRQHandler(void)
{
}

void DMA1_Channel1_IRQHandler(void)
{
  	Send_Buffer[0] = 0x07;
  
  	if((ADC_ConvertedValueX >>4) - (ADC_ConvertedValueX_1 >>4) > 4)
  	{
    	Send_Buffer[1] = (u8)(ADC_ConvertedValueX >>4);
    	UserToPMABufferCopy(Send_Buffer, ENDP1_TXADDR, 2);
    	SetEPTxCount(ENDP1, 2);
    	SetEPTxValid(ENDP1);
    	ADC_ConvertedValueX_1 = ADC_ConvertedValueX;
  	}
  
  	DMA_ClearFlag(DMA1_FLAG_TC1);
}

void DMA1_Channel2_IRQHandler(void)
{
}

void DMA1_Channel3_IRQHandler(void)
{
}

void DMA1_Channel4_IRQHandler(void)
{
}

void DMA1_Channel5_IRQHandler(void)
{
}

void DMA1_Channel6_IRQHandler(void)
{
}

void DMA1_Channel7_IRQHandler(void)
{
}

void ADC1_2_IRQHandler(void)
{
}

void USB_HP_CAN_TX_IRQHandler(void)
{
}

void USB_LP_CAN_RX0_IRQHandler(void)
{
    USB_Istr();
}

void CAN_RX1_IRQHandler(void)
{
}

void CAN_SCE_IRQHandler(void)
{
}

void EXTI9_5_IRQHandler(void)
{
  	if(EXTI_GetITStatus(GPIO_KEY_EXTI_Line) != RESET)
  	{  
    	Send_Buffer[0] = 0x05;
    
    	if (GPIO_ReadInputDataBit(GPIO_KEY, GPIO_KEY_PIN) == Bit_RESET)
      		Send_Buffer[1] = 0x01;
    	else 
      		Send_Buffer[1] = 0x00;
    
    	UserToPMABufferCopy(Send_Buffer, ENDP1_TXADDR, 2);
    	SetEPTxCount(ENDP1, 2);
    	SetEPTxValid(ENDP1);

    	EXTI_ClearITPendingBit(GPIO_KEY_EXTI_Line);
  	}
}

void TIM1_BRK_IRQHandler(void)
{
}

void TIM1_UP_IRQHandler(void)
{
}

void TIM1_TRG_COM_IRQHandler(void)
{
}

void TIM1_CC_IRQHandler(void)
{
}

void TIM2_IRQHandler(void)
{
}

void TIM3_IRQHandler(void)
{
}

void TIM4_IRQHandler(void)
{
}

void I2C1_EV_IRQHandler(void)
{
}

void I2C1_ER_IRQHandler(void)
{
}

void I2C2_EV_IRQHandler(void)
{
}

void I2C2_ER_IRQHandler(void)
{
}

void SPI1_IRQHandler(void)
{
}

void SPI2_IRQHandler(void)
{
}

void USART1_IRQHandler(void)
{
}

void USART2_IRQHandler(void)
{
}

void USART3_IRQHandler(void)
{
}

void EXTI15_10_IRQHandler(void)
{
  	if(EXTI_GetITStatus(GPIO_TAMPER_EXTI_Line) != RESET)
  	{  
    	Send_Buffer[0] = 0x06;
    
    	if (GPIO_ReadInputDataBit(GPIO_TAMPER, GPIO_TAMPER_PIN) == Bit_RESET)
      		Send_Buffer[1] = 0x01;
    	else 
      		Send_Buffer[1] = 0x00;
    
    	UserToPMABufferCopy(Send_Buffer, ENDP1_TXADDR, 2);
    	SetEPTxCount(ENDP1, 2);
    	SetEPTxValid(ENDP1);

    	EXTI_ClearITPendingBit(GPIO_TAMPER_EXTI_Line);
  	}
}

void RTCAlarm_IRQHandler(void)
{
}

void USBWakeUp_IRQHandler(void)
{
}

void TIM8_BRK_IRQHandler(void)
{
}

void TIM8_UP_IRQHandler(void)
{
}

void TIM8_TRG_COM_IRQHandler(void)
{
}

void TIM8_CC_IRQHandler(void)
{
}

void ADC3_IRQHandler(void)
{
}

void FSMC_IRQHandler(void)
{
}

void SDIO_IRQHandler(void)
{
}

void TIM5_IRQHandler(void)
{
}

void SPI3_IRQHandler(void)
{
}

void UART4_IRQHandler(void)
{
}

void UART5_IRQHandler(void)
{
}

void TIM6_IRQHandler(void)
{
}

void TIM7_IRQHandler(void)
{
}

void DMA2_Channel1_IRQHandler(void)
{
}

void DMA2_Channel2_IRQHandler(void)
{
}

void DMA2_Channel3_IRQHandler(void)
{
}

void DMA2_Channel4_5_IRQHandler(void)
{
}

